﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Diagnostics;

namespace LWP.NavigationSamples
{
    public partial class AllNavigationEvents : PhoneApplicationPage
    {
        public AllNavigationEvents()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(AllNavigationEvents_Loaded);
            this.instanceId = nextId++; 
        }

        void AllNavigationEvents_Loaded(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine("Loaded " + instanceId);
           

            PageTitle.Text = "Instance " + instanceId;

            backButton.IsEnabled = NavigationService.CanGoBack;
            forwardButton.IsEnabled = NavigationService.CanGoForward; 

        }

        void AllNavigationEvents_Unloaded(object sender, RoutedEventArgs e)
        {
            
            
        }

        void AllNavigationEvents_NavigationStopped(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine("PhoneApplicationFrame.NavigationStopped " + e.Uri); 
        }

        void AllNavigationEvents_Navigated(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine("PhoneApplicationFrame.Navigated to " + e.Uri); 
        }

        void AllNavigationEvents_Navigating(object sender, System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            Debug.WriteLine("PhoneApplicationFrame.Navigating to " + e.Uri); 
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);
            Debug.WriteLine("PhoneApplicationPage.OnNavigatedFrom " + instanceId); 

            
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            Debug.WriteLine("PhoneApplicationPage.OnNavigatedTo " + instanceId);
            
            // the first time this is loaded, we start listening
            if (instanceId == 0 && nextId == 1 )
            {
                //NOTE: This leads to a memory leak.  We should 
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigating += AllNavigationEvents_Navigating;
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigated += AllNavigationEvents_Navigated;
                ((PhoneApplicationFrame)App.Current.RootVisual).NavigationStopped += AllNavigationEvents_NavigationStopped;

            }
        }

        protected override void OnNavigatingFrom(System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            base.OnNavigatingFrom(e);
            Debug.WriteLine("PhoneApplicationPage.OnNavigatingFrom " + instanceId);

            if (e.NavigationMode == System.Windows.Navigation.NavigationMode.Back &&
                this.instanceId == 0)
            {
                System.Diagnostics.Debug.WriteLine("Stopped listening to nav events");
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigating -= AllNavigationEvents_Navigating;
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigated -= AllNavigationEvents_Navigated;
                ((PhoneApplicationFrame)App.Current.RootVisual).NavigationStopped-= AllNavigationEvents_NavigationStopped;
            } 
        }

        void OnBack(object unused, RoutedEventArgs unused2)
        {
            if (NavigationService.CanGoBack)
                NavigationService.GoBack(); 

        }

        void OnForward(object unused, RoutedEventArgs unused2)
        {
            if (NavigationService.CanGoForward)
                NavigationService.GoForward();

        } 

        static int nextId;
        int instanceId; 

        void OnNavigateNext(object unused, RoutedEventArgs unused2)
        {
            string next = string.Format("/AllNavigationEvents.xaml?nextId={0}", nextId);
            Uri uri = new Uri(next, UriKind.Relative);
            this.NavigationService.Navigate(uri);

        } 
    }
}