﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace LWP.NavigationSamples
{
    public partial class BackNavCancelledOnBackKeyPress : PhoneApplicationPage
    {
        public BackNavCancelledOnBackKeyPress()
        {
            nextId++; 
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(BackNavCancelledOnBackKeyPress_Loaded);
        }

        void BackNavCancelledOnBackKeyPress_Loaded(object sender, RoutedEventArgs e)
        {
            this.ApplicationTitle.Text = "BackNavCancelledOnBackKeyPress".ToUpper();
            this.BackKeyPress += new EventHandler<System.ComponentModel.CancelEventArgs>(BackNavCancelledOnBackKeyPress_BackKeyPress);
        }

        void BackNavCancelledOnBackKeyPress_BackKeyPress(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (this.cancelAtBackKeyPressEvent.IsChecked.Value)
            {
                e.Cancel = true;               
            } 
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            if (NavigationContext.QueryString.ContainsKey("pagetitle"))
                this.PageTitle.Text = "instance # " + NavigationContext.QueryString["pagetitle"];
        }


        protected override void  OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
 	        base.OnBackKeyPress(e);
            if (this.cancelAtOnBackKeyPressCallback.IsChecked.Value)
            {
                e.Cancel = true;

                //if (e.NavigationMode == System.Windows.Navigation.NavigationMode.Back)
                //    this.status.Text = "Now we can be indeterminate and nav can be broken. it happens selcomly, so try again if it did not happen";
            }
        }



        static int nextId;
        void OnNavigateNext(object unused, RoutedEventArgs unused2)
        {
            string next = string.Format("/BackNavCancelledOnBackKeyPress.xaml?pagetitle={0}", nextId);
            Uri uri = new Uri(next, UriKind.Relative);
            this.NavigationService.Navigate(uri);

        } 
    }
}