﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace LWP.NavigationSamples
{
    public partial class GarbageCollectedSample : PhoneApplicationPage 
    {
        static int activePageCount;
        static object staticLock = new object();
        int instanceId; 
        public GarbageCollectedSample()
        {
            InitializeComponent();
            lock (staticLock)
            {
                activePageCount++;
                instanceId = ++nextId; 
            }

            this.Loaded += new RoutedEventHandler(GarbageCollectedSample_Loaded);
        }

        void GarbageCollectedSample_Loaded(object sender, RoutedEventArgs e)
        {
            System.GC.Collect();
            System.GC.Collect();
            System.GC.Collect();
            pageCount.Text = string.Format("{0} active pages in memory", activePageCount);
 
            this.PageTitle.Text = "instance " + instanceId; 
        }

        ~GarbageCollectedSample()
        {
            lock (staticLock)
            {
                activePageCount--;
            } 
        }


        static int nextId;
        void OnNavigateNext(object unused, RoutedEventArgs unused2)
        {
            string next = string.Format("/GarbageCollectedSample.xaml?pagetitle={0}", nextId);
            Uri uri = new Uri(next, UriKind.Relative);
            this.NavigationService.Navigate(uri);

        } 
    }
}