﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Controls.Primitives;

namespace LWP.NavigationSamples
{
    //TRANSIENT STEP 0:  
    public partial class TransientUISample : PhoneApplicationPage
    {
        public TransientUISample()
        {
            InitializeComponent();
        }


        Popup loginDialogPopup;
        LoginUserControl loginDialog; 
        bool applicationBarVisibilityPreDialog;
        bool isShowingTransientUI; 

        private void OnPopup(object unused1, RoutedEventArgs unused2)
        {
            OnShowTransientUI(true); 
        }

        private void OnInlinePopup(object unused1, RoutedEventArgs unused2)
        {
            OnShowTransientUI(false);
        }


        //TRANSIENT STEP 2:
        private void OnShowTransientUI(bool usingPopup)
        {

            //TRANSIENT STEP 2.1:
            if (this.ApplicationBar != null)
            {
                applicationBarVisibilityPreDialog = this.ApplicationBar.IsVisible;
                this.ApplicationBar.IsVisible = false; 
            } 

            
            loginDialog = new LoginUserControl();
            // we do this width/heights because our page has not Measured/Arranged 
            // since we disabled ApplicationBar..  
            // if you want ApplicationBar to stay visible, simply use ActualWidth/ActualHeight 
            loginDialog.Width =  ( this.ActualWidth > 480 ) ?  800 : 480 ;
            loginDialog.Height = (this.ActualHeight > 480) ? 800 : 480;

            loginDialog.LoginCompleted += new EventHandler<EventArgs>(loginDialog_LoginCompleted);           


            Storyboard sb = this.Resources["SlideUpFadeIn"] as Storyboard;
            if (usingPopup)
            {
                loginDialogPopup = new Popup();
                loginDialogPopup.RenderTransform = new CompositeTransform();
                loginDialogPopup.Child = loginDialog;
                loginDialogPopup.IsOpen = true;
                Storyboard.SetTarget(sb, loginDialogPopup);
                LayoutRoot.Children.Add(loginDialogPopup);
            }
            else
            {
                loginDialog.RenderTransform = new CompositeTransform();
                LayoutRoot.Children.Add(loginDialog);
                Storyboard.SetTarget(sb, loginDialog);                
            }
            isShowingTransientUI = true; 
            sb.Completed += new EventHandler(sb_Completed);
            sb.Begin(); 
            
        }

        void sb_Completed(object sender, EventArgs e)
        {
            Storyboard sb = sender as Storyboard; 
            sb.Stop();  
            System.Diagnostics.Debug.WriteLine("Completed"); 
            
        }

        void DismissTransientUI()
        {
            if (this.ApplicationBar != null)
            {
                this.ApplicationBar.IsVisible = applicationBarVisibilityPreDialog;
            }

            if (loginDialogPopup != null)
            {
                loginDialogPopup.IsOpen = false;

                LayoutRoot.Children.Remove(loginDialogPopup);
                loginDialogPopup = null;

            }
            else
            {
                LayoutRoot.Children.Remove(loginDialog);
            }
            isShowingTransientUI = false; 
        } 

        void loginDialog_LoginCompleted(object unused1, EventArgs unused2)
        {
            DismissTransientUI();
            NavigationService.Navigate( new Uri ( "/LoggedIn.xaml", UriKind.Relative)); 
        }

        //TRANSIENT STEP 3:
        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            base.OnBackKeyPress(e);

            if (isShowingTransientUI)
            {
                e.Cancel = true;
                DismissTransientUI(); 
            } 
        } 
         
    }
}